using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
 
namespace OlItemsContextMenu
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("1194263C-217F-4735-B000-90023CECBDB1"), ProgId("OlItemsContextMenu.AddinModule"), RunInstaller(true)]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule(System.ComponentModel.IContainer container)
        {
            // This call is required by the Component Designer
            container.Add(this);
            InitializeComponent();
 
            // TODO: Add any initialization after the InitializeComponent call
        }

		private AddinExpress.MSO.ADXOutlookAppEvents adxOutlookEvents;
		private AddinExpress.MSO.ADXCommandBar adxCommandBar = null;

        public AddinModule()
        {
            InitializeComponent();
        }
 
        // Add-in Module Implementation
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
			this.components = new System.ComponentModel.Container();
			this.adxOutlookEvents = new AddinExpress.MSO.ADXOutlookAppEvents(this.components);
			// 
			// adxOutlookEvents
			// 
			this.adxOutlookEvents.CommandBarsUpdate += new System.EventHandler(this.adxOutlookEvents_CommandBarsUpdate);
			// 
			// AddinModule
			// 
			this.AddinName = "Outlook Items Context Menu Example";
			this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaOutlook;

		}
        #endregion
 
        #region ADX automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

		internal Outlook._Application OutlookApp
		{
			get
			{
				return (HostApplication as Outlook._Application);
			}
		}

		private void adxOutlookEvents_CommandBarsUpdate(object sender, System.EventArgs e)
		{
			DoCommandBarsUpdate(this);
		}

		private void DoOpenOptionPage(object sender)
		{
			MyPropertyPage properties = null;
			try
			{
				properties = new MyPropertyPage();
				if (properties.ShowDialog() == DialogResult.OK)
				{
				}
			}
			finally
			{
				if (properties != null)
					properties.Dispose();
			}
		}

		internal void AddControl(Office.CommandBar contextBar, string caption, string controlTag, int before, AddinExpress.MSO.ADXClick_EventHandler eventHandler)
		{
			AddinExpress.MSO.ADXCommandBarButton adxNewButton = null;
			Office.CommandBarControl newButton = 
				contextBar.FindControl(Office.MsoControlType.msoControlButton, Type.Missing, controlTag, Type.Missing, Type.Missing) as Office.CommandBarControl;
			if (newButton == null)
			{
				contextBar.Protection = Office.MsoBarProtection.msoBarNoProtection;
				if (adxCommandBar == null)
				{
					adxCommandBar = new AddinExpress.MSO.ADXCommandBar();
					adxCommandBar.CommandBarObj = contextBar;
				}
				else
				{
					adxNewButton = adxCommandBar.Controls.GetControlByControlTag(controlTag, false) as AddinExpress.MSO.ADXCommandBarButton;
					if (adxNewButton != null)
					{
						adxNewButton.ControlObj = null;
						adxCommandBar.Controls.RemoveAt(adxCommandBar.Controls.IndexOf(adxNewButton));
					}
				}
				adxNewButton = new AddinExpress.MSO.ADXCommandBarButton();
				adxNewButton.ControlTag = controlTag;
				adxNewButton.Before = before;
				adxNewButton.Temporary = true;
				adxNewButton.BeginGroup = true;
				adxNewButton.Style = AddinExpress.MSO.ADXMsoButtonStyle.adxMsoButtonCaption;
				adxNewButton.Caption = caption;
				adxNewButton.Click += eventHandler;
				if (adxCommandBar.Controls.Add(adxNewButton) != null)
				{
					adxNewButton.ControlObj = contextBar.Controls.Add(Office.MsoControlType.msoControlButton, Type.Missing, Type.Missing, (adxNewButton.Before>0?adxNewButton.Before:Type.Missing), true);
					adxNewButton.UpdateControlObj(this);
				}
			}
			else
			{
				Marshal.ReleaseComObject(newButton);
			}
		}

		internal void DoCommandBarsUpdate(object sender)
		{
			Outlook.Selection sel = null;
			Outlook.NameSpace nameSpace = null;
			Outlook.Explorer activeExplorer = null;
			Outlook.MAPIFolder defaultFolder = null;
			Outlook.MAPIFolder currentFolder = null;

			try
			{
				nameSpace = OutlookApp.GetNamespace("MAPI");
				activeExplorer = OutlookApp.ActiveExplorer();
				try
				{
					defaultFolder = nameSpace.GetDefaultFolder(Outlook.OlDefaultFolders.olFolderInbox);
					currentFolder = activeExplorer.CurrentFolder;
					try
					{
						sel = activeExplorer.Selection;
					}
					catch
					{
					}

					Office.CommandBar contextBar = null;
					if (sel != null && (sel.Count > 1 && currentFolder.EntryID == defaultFolder.EntryID))
					{
						this.CommandBarsObj = activeExplorer.CommandBars;	
						try
						{
							contextBar = this.FindCommandBarObj("Context Menu") as Office.CommandBar;
							if (contextBar != null)
							{
								if (contextBar.Controls.Count > 0)
								{
									try
									{
										AddControl(contextBar, "My Action", "MY_UNIQUE_TAG 1", 2, new AddinExpress.MSO.ADXClick_EventHandler(DoClick));
										AddControl(contextBar, "My Option Page", "MY_UNIQUE_TAG 2", 0, new AddinExpress.MSO.ADXClick_EventHandler(DoOpenOptionPage));
									}
									catch
									{
									}
								}
							}
						}
						finally
						{
							if (contextBar != null)
								Marshal.ReleaseComObject(contextBar);
						}
						this.CommandBarsObj = null;
					}
				}
				finally
				{
					if (sel != null)
						Marshal.ReleaseComObject(sel);
					if (defaultFolder != null)
						Marshal.ReleaseComObject(defaultFolder);
					if (currentFolder != null)
						Marshal.ReleaseComObject(currentFolder);
				}
			}
			finally
			{
				if (nameSpace != null)
					Marshal.ReleaseComObject(nameSpace);
				if (activeExplorer != null)
					Marshal.ReleaseComObject(activeExplorer);
			}
		}
 
		private void DoClick(object sender)
		{
			MessageBox.Show((sender as AddinExpress.MSO.ADXCommandBarControl).Caption, AddinName);
		}
	}
}

